#import "View.h"
#import "Controller.h"

@implementation View

- (void)method:(NSButton*)sender {
    [target action:[self title]];
}

- (void)input:(NSTextField*)sender {
    [target action:[sender stringValue]];
}

- (void)retrn:(NSButton*)sender {
    [target action:@"\r"];
}

- (void)title:(NSButton*)sender {
    [target action:[sender title]];
}

- (void)callMethod:(int)sum {
  [method setEnabled:YES];
  [return1 setEnabled:YES];
  [input setEditable:YES];
  [total setIntValue:sum];
  [raise setEnabled:YES];
  [handle setEnabled:NO];
  [up setEnabled:NO];
  [return2 setEnabled:NO];
}

- (void)callRaise:(int)sum {
  [method setEnabled:NO];
  [return1 setEnabled:NO];
  [input setEditable:YES];
  [total setIntValue:sum];
  [raise setEnabled:NO];
  [handle setEnabled:YES];
  [up setEnabled:YES];
  [return2 setEnabled:YES];
}

- (void)setSum:(int)sum {
  [input setStringValue:@""];
  [total setIntValue:sum];
}

- (void)reset:(BOOL)flag {
  [method setEnabled:flag];
  [return1 setEnabled:NO];
  [input setEditable:NO];
  [raise setEnabled:NO];
  [handle setEnabled:NO];
  [up setEnabled:NO];
  [return2 setEnabled:NO];
}
@end
