#import "Model.h"

@interface Test: NSObject <IO>
@end

static NSString * readLine () {
    char buf [BUFSIZ];
    if (!fgets(buf, sizeof buf, stdin)) exit(1);
    buf[strlen(buf)-1] = '\0';
    return strlen(buf) ? [NSString stringWithCString:buf] : @"\r";
}

@implementation Test
- (NSString*)inRaise:(NSString*)stack :(NSString*)name :(int)sum {
    printf("%s\traise\tsuper or handle, else return: ", [stack cString]);
    return readLine();
}

- (NSString*)inMethod:(NSString*)stack :(NSString*)name :(int)sum {
    printf("%s\tmethod\tA.. or raise, else return: ", [stack cString]);
    return readLine();
}

- (void)setSum:(NSString*)name :(int)sum {
}

- (void)handleInfo:(NSString*)name :(int)sum :info {
    printf("\tmethod\thandling %s\n", [[info description] cString]);
}

- (void)leaveRaise:(NSString*)name {
    puts("\traise\tquits");
}

- (void)leaveMethod:(NSString*)name {
    puts("\tmethod\tquits");
}
@end

int main () {
  NSAutoreleasePool * pool = [NSAutoreleasePool new];
  id<IO> io = [Test new];
  [[Model alloc] initWithName:@"B" io:io];
  [[Model alloc] initWithName:@"C" io:io];
  [[[Model alloc] initWithName:@"A" io:io] method:nil];
  [pool release];
  return 0;
}
