

!!! Listing 1

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

<!-- Rest des Stylesheets -->

</xsl:stylesheet>

!!! Listing 2

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
  xmlns="http://www.w3.org/TR/REC-html40"
  result-ns="">

<!-- Rest des Stylesheets -->

</xsl:stylesheet>

!!! Listing 3

<xsl:template match="line">
  <xsl:apply-templates /><br />
</xsl:template>

!!! Listing 4

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
  xmlns="http://www.w3.org/TR/REC-html40"
  result-ns="">

<xsl:import href="poem.xsl"/>

<xsl:template match="line">
    <xsl:if test="position()=last()">
      <img src="images/1pixel.gif" width="75" height="1" />
    </xsl:if>
  <xsl:apply-templates/><br />
</xsl:template>

</xsl:stylesheet>

!!! Listing 5

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
  xmlns="http://www.w3.org/TR/REC-html40"
  result-ns="">

<xsl:template match="/">
  <html>
    <head>
     <title><xsl:apply-templates select="poem/title" mode="head"/></title>
    </head>
    <body>
      <xsl:apply-templates select="poem"/>
    </body>
  </html>
</xsl:template>

<xsl:template match="poem">
  <xsl:apply-templates select="stanza"/>
</xsl:template>

<xsl:template match="stanza">
  <p><xsl:apply-templates select="line"/></p>
</xsl:template>

<xsl:template match="line">
  <xsl:apply-templates /><br />
</xsl:template>

<xsl:template match="title">
  <h3><xsl:value-of select="."/></h3>
</xsl:template>

<xsl:template match="title" mode="head">
  <xsl:value-of select="."/>
</xsl:template>

</xsl:stylesheet>

!!! Listing 6

java -Dcom.jclark.xsl.sax.parser=com.jclark.xml.sax.Driver \
  com.jclark.xsl.sax.Driver \
  $1.xml $2.xsl $3.html
