import java.awt.*;
import java.awt.event.*;

public class View extends Panel {
  private Panel content = new Panel(new BorderLayout());
  { content.setBackground(Color.lightGray);
  }

  private final Button method = new Button("method");
  private final Button return1 = new Button("return");
  { Label l;
    Panel p = new Panel(new GridLayout(1,3, 2,2));
      p.add(method);
      p.add(l = new Label()); l.setBackground(Color.lightGray);
      p.add(return1); return1.setEnabled(false);
    content.add(p, BorderLayout.NORTH);
  }

  private final TextField input = new TextField();
  private final Label total = new Label("0", Label.CENTER);
  { Panel p = new Panel(new GridLayout(1,2, 2,2));
      p.add(input); input.setEnabled(false); input.setBackground(Color.white);
      p.add(total); total.setBackground(Color.lightGray);
    content.add(p, BorderLayout.CENTER);
  }

  private final Button raise = new Button("raise");
  private final Button handle = new Button("handle");
  private final Button up = new Button("super");
  private final Button return2 = new Button("return");
  { Label l;
    Panel p = new Panel(new GridLayout(2,3, 2,2));
      p.add(raise); raise.setEnabled(false);
      p.add(handle); handle.setEnabled(false);
      p.add(l = new Label()); l.setBackground(Color.lightGray);
      p.add(l = new Label()); l.setBackground(Color.lightGray);
      p.add(up); up.setEnabled(false);
      p.add(return2); return2.setEnabled(false);
    content.add(p, BorderLayout.SOUTH);
  }

  public View (String title, ActionListener al) {
    super(new BorderLayout(2,2)); setBackground(Color.darkGray);

    Label l = new Label(title, Label.CENTER); l.setBackground(Color.lightGray);
    add(l, BorderLayout.NORTH);

    add(content, BorderLayout.CENTER);

    method.addActionListener(al); method.setActionCommand(title);
    return1.addActionListener(al); return1.setActionCommand("\r");
    input.addActionListener(al);
    raise.addActionListener(al);
    handle.addActionListener(al);
    up.addActionListener(al);
    return2.addActionListener(al); return2.setActionCommand("\r");
  }

  public void callMethod (int sum) {
    method.setEnabled(true);
    return1.setEnabled(true);
    input.setEnabled(true);
    total.setText(""+sum);
    raise.setEnabled(true);
    handle.setEnabled(false);
    up.setEnabled(false);
    return2.setEnabled(false);
  }

  public void callRaise (int sum) {
    method.setEnabled(false);
    return1.setEnabled(false);
    input.setEnabled(true);
    total.setText(""+sum);
    raise.setEnabled(false);
    handle.setEnabled(true);
    up.setEnabled(true);
    return2.setEnabled(true);
  }

  public void setSum (int sum) {
    input.setText("");
    total.setText(""+sum);
  }

  public void reset (boolean state) {
    method.setEnabled(state);
    return1.setEnabled(false);
    input.setEnabled(false);
    raise.setEnabled(false);
    handle.setEnabled(false);
    up.setEnabled(false);
    return2.setEnabled(false);
  }
}
