#import "Activation.h"

@implementation Activation
- initWithCaller:(Activation*)_caller {
    [super initWithName:@"Activation" reason:@"handle"
			userInfo:[[NSMutableDictionary dictionary] retain]];
    *(Activation**)&caller = _caller;
    return self;
}

- (void)dealloc {
    [[self userInfo] release];
}

- raise:info {
    return caller ? [caller raise:info] : info;
}

- (void)handle:info {
    [(NSMutableDictionary*)[self userInfo] setObject:info forKey:@"info"];
    [self raise];
}
@end
